/* Problem URL: https://codeforces.com/contest/2152/problem/C */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, q;
    cin >> n >> q;

    vi a(n);
    cin >> a;

    if (n == 1) {
        while (q--) {
            int a, b;
            cin >> a >> b;
            cout << "-1\n";
        }
        return;
    }

    V<bool> val(n);

    nrep(i, 1, n - 1) {
        if (a[i] != a[i - 1] && a[i] != a[i + 1]) {
            val[i] = true;
        }
    }

    if (a[0] != a[1]) {
        val[0] = true;
    }

    if (a[n - 1] != a[n - 2]) {
        val[n - 1] = true;
    }

    vi count(n + 1);
    rep(i, n) {
        count[i + 1] = count[i] + a[i];
    }

    vvi sparse(20, vi(n));
    rep(i, n) {
        sparse[0][i] = val[i];
    }

    nrep(j, 1, 20) {
        for (int i = 0; i + (1 << (j - 1)) < n; i++) {
            sparse[j][i] = sparse[j - 1][i] && sparse[j - 1][i + (1 << (j - 1))];
        }
    }

    auto query = [&](int l, int r) {
        int log = 31 - __builtin_clz(r - l + 1);
        return sparse[log][l] & sparse[log][r - (1 << log) + 1];
    };
    
    while (q--) {
        int l, r;
        cin >> l >> r;
        l--, r--;

        if ((r - l + 1) % 3 || (count[r + 1] - count[l]) % 3) {
            cout << "-1\n";
            continue;
        }

        cout << (r - l + 1) / 3 + (query(l + 1, r - 1) & (a[l] != a[l + 1]) & (a[r] != a[r - 1])) << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
